<?php
App::uses('BuzzWaiversComponent', 'BuzzWaivers.Controller/Component');

class BookingCheckComponent extends BuzzWaiversComponent {

	public $_controller = null;

	public function check($data) {

		$bookingRefs = array_keys($data);

		$Participant = ClassRegistry::init('BuzzWaivers.Participant');

		$participants = $Participant->find('all', array(
			'conditions' => array(
				'sales_ref' => $bookingRefs
			)
		));

		$waiverCount = array();
		$participantIds = array();

		if (! empty($participants)) {
			foreach($participants as $participantKey => $participant) {
				$salesRef = $participant['Participant']['sales_ref'];
				if ($participant['Participant']['waiver_complete'] == '1') {
					if (! empty($waiverCount[$salesRef])) {
						$waiverCount[$salesRef] = $waiverCount[$salesRef] + 1;
					} else {
						$waiverCount[$salesRef] = 1;
					}

					if (! empty($waiverCount[$salesRef]) && $waiverCount[$salesRef] >= count($data[$salesRef])) {
						// All waivers complete
						foreach($data[$salesRef] as $key => $item) {
							$data[$salesRef][$key]['message'] = ' <i class="fa fa-check"></i> ' . __d('buzz_waivers', 'All Waivers Signed');
							$data[$salesRef][$key]['waiverCompleted'] = true;
						}
					}
				}

				$participantIds[$salesRef] = $participant['Participant']['id'];
			}
		}

		$this->_controller->set('participants', $participantIds);
		$this->_controller->set('showWaivers', true);

		return $data;

	}

}
